"""
Malte Braack, Naveen Kumar Parameswaran
CAU, Kiel University, Germany

https://www.pec3.org/events/school2022/

Exercise Class 3 - Numerical Optimization
"""

from newton import Newton
from exercise1 import MyFunction
from methods import newton_Rn

#------------------------------------------
# Subroutines
#------------------------------------------

class MyNewtonFunction:

	def __init__(self,f):
		self.f = f

	def F(self,x):
    	 return 0.		# <--  PUT HERE THE GRADIENT OF f

	def Jac(self,x):
		return 0.		# <--  PUT HERE THE HESSIAN OF f

#------------------------------------------

def Exercise3(x):
	f = MyNewtonFunction(MyFunction())
	Newton().run(f,x)
	# Newton from Stefan Frei
	# [x,it,res] = newton_Rn(f.F, f.Jac, x, 100, 1.e-8)
	# print (it, ": " , x, " res = ", '%.4e' % res[it])

#------------------------------------------
# Main programme
#------------------------------------------

print ("\nExercise 3:")
x0 =  [0.1 , 1.]
Exercise3(x0)
	